package org.jboss.esb.quickstart.helloworldmbean.action;

import javax.management.InstanceNotFoundException;
import javax.management.MBeanException;
import javax.management.MBeanServer;
import javax.management.MBeanServerFactory;
import javax.management.ObjectName;
import javax.management.ReflectionException;

import org.jboss.soa.esb.ConfigurationException;
import org.jboss.soa.esb.actions.AbstractActionLifecycle;
import org.jboss.soa.esb.actions.ActionProcessingException;
import org.jboss.soa.esb.helpers.ConfigTree;
import org.jboss.soa.esb.message.Message;

public class QuickstartHelloAction extends AbstractActionLifecycle {

	private MBeanServer server;
	
	private ObjectName oname;
	
	public QuickstartHelloAction(ConfigTree config) throws ConfigurationException{
		
		server = (MBeanServer) MBeanServerFactory.findMBeanServer(null).get(0);
		try {
			oname = new ObjectName("Quickstart:name=Helloworld");
		//	server.registerMBean(new QuickstartHelloworld(), oname);
		} catch (Exception e) {
			throw new ConfigurationException(e);
		} 
	}
	
	public Message process(Message message) throws ActionProcessingException{
	
		
		try {
			server.invoke(oname, "addAddMessageCount",
				       new Object[] {}, // empty argument list
				       new String[] {}); // void signature
					
		} catch (InstanceNotFoundException e) {
			throw new ActionProcessingException(e);
		} catch (MBeanException e) {
			throw new ActionProcessingException(e);
		} catch (ReflectionException e) {
			throw new ActionProcessingException(e);
		} 
		
		System.out.println(message.getBody().get());
        return message;
	}
}
